/*
 *  matblc1.h
 *  Ulambator v0.3
 *
 *  Created by Mathias Nagel on 29.01.10.
 *  Copyright 2010 EPFL. All rights reserved.
 *
 */

#ifndef MATBLC1_H
#define MATBLC1_H

#include "matrixblock.h"

class MatBlC1 : public MatrixBlock {
public:
	MatBlC1(BndBlock *bembl, double aspectRatio, double viscRatio, double capillaryNumber);
// 	    void ForceFree(int fblock, double dEta, double dgap);

protected:
	
	void CircTrac(int inP,double delT);								// Boundary condition for droplet for Corner Centered Elements
	void SCircTrac(int inP, double delT);
//    void FilmTrac(int inP,double delT);
	void BoosThess(int inP);							// Analytical test case
//	void BordTrac(int inP,double delT);
//    void SBordTrac(int inP, double delT);
	void ZeroVel(int inP);								// Boundary condition for walls
	void SZeroVel(int inP);
    void FlatVel(int inP, double, double, double, double);					// Boundary condition for fixed velocity
    void SFlatVel(int inP, double, double, double, double);
//   void FlatVelrhs(int inP, double Vn, double Vt, double Theta, double dEta, int insert);
//    void SFlatVelrhs(int inP, double Vn, double Vt, double Theta, double dEta, int insert);
	void NormVel(int inP, double, double,double);
    void SNormVel(int inP, double, double,double);
    void POX(int inP, double plevel, double dEta);
    void SPOX(int inP, double plevel, double dEta);
	void Pressure(int inP, double plevel, double dEta);
    void SPressure(int inP, double plevel, double dEta);
	void Poiseuille(int inP, double qdebit, double dEta);
    void SPoiseuille(int inP, double qdebit, double dEta);
    void InfiniBox(double xvel, double yvel);
    void InfiniSource(double qdebit, double xpos, double ypos, double dEta);
    void InfiniLinearFlow(double lin, double colin, double dEta);
    void FiniLinearFlow(int, double lin, double colin, double dEta);
    void SineFlow(int inP, double, double,double);
    void SSineFlow(int inP, double, double,double);
    
//    void FilmTrac(double *erhs);
    
    void VisuZeroVel(int inP, double *Xpos, double *Ypos,int points, double *U, double *V, double *P);
    void VisuNormVel(int inP,double *Xpos, double *Ypos, double varA, double varB, double dEta, int points, double *U, double *V, double *P);
    void VisuFlatVel(int inP,double *Xpos, double *Ypos, double varA, double varB, double Theta, double dEta, int points, double *U, double *V, double *P);
    void VisuPressure(int inP,double *Xpos, double *Ypos, double varA, double dEta, int points, double *U, double *V, double *P);
    void VisuPOX(int inP,double *Xpos, double *Ypos, double varA, double dEta, int points, double *U, double *V, double *P);
    void VisuPoiseuille(int inP,double *Xpos, double *Ypos, double varA, double dEta, int points, double *U, double *V, double *P);
    void VisuCircTrac(int inP,double *Xpos, double*Ypos, int points, double *U, double *V, double *P);
//    void VisuBordTrac(int inP,double *Xpos, double*Ypos, int points, double *U, double *V, double *P);
    void VisuInfiniBox(double * Xpos, double *Ypos, double uvel, double vvel, int points, double *U, double *V, double *P, int *Dom);
    void VisuInfiniSource(double *Xpos, double *Ypos, double qdebit, double xpos, double ypos, double Eta, int points, double *U, double *V, double *P);
    void VisuLinearFlow(double *Xpos, double *Ypos, double lin, double colin, int points, double *U, double *V, double *P, int *Dom);
    void VisuFiniFlow(int inP,double *Xpos, double *Ypos, double varA, double varB, double dEta, int points, double *U, double *V, double *P);
    void VisuSineFlow(int inP,double *Xpos, double *Ypos, double varA, double varB, double dEta, int points, double *U, double *V, double *P);
    
    

	void GetPressure();
	double getUvel(int dropId, int, int, int);
    void getForce(int WallId, int nbSeg, double* ForceX, double* sol);
};


#endif
