# An example of how to plot Ulambator data with Python
# This shows a few basic plot types and should serve as a starting point for your own plot template

import sys
# If necessary specify the folder containing the ulamPythonPlotLib.py file
sys.path.append('.')
import ulamPythonPlotLib as upp
import pylab as pl

# ---- Following Section plots an external boundary with a droplet interface ----

# Loading the data from two files
bnd0 = upp.readBoundary('bnd0pos.dat')
drop1 = upp.readBoundary('drop1ts1.dat')

# Ploting both
upp.plotBoundary(bnd0,'-')
upp.plotBoundary(drop1,'-')

# Showing the figure
pl.show()

# ---- Following Section plots all droplet boundaries ----

# Reading data, this works for droplet id 1 and for all time steps
data = upp.readAllBoundaries('drop1ts(\d+).dat')

# Plots time step at a time with a pause of pauseSec seconds
pauseSec= 0.1
upp.plotAllBoundaries(data,'-',pauseSec)

# ---- Following Section Plots Field Data ----

# Read data from file
# File name is to be specified
[xpos,ypos,xvel,yvel,press,header] = upp.readViz('ulamviz0.dat')

# Contour plot
pl.contourf(xpos,ypos,press,100)
pl.show()

#Velocity vector plot
pl.quiver(xpos,ypos,xvel,yvel)
pl.show()
