%% Visualize field data from Ulambator
% Load Data from numerated file

file_num = 0;
thepath = ('~/tmp');
filename  = [thepath,'/ulamviz',num2str(file_num),'.dat'];

% Open file and read header and data
fid = fopen(filename);
for n=1:2
   s = fgetl(fid);
end

header_data = str2num(s);
delimString = ' ';
ulam_data = dlmread(filename,' ',2,0);
fclose(fid);

% Dimensions of array and window size
xsize = header_data(1);
ysize = header_data(2);
bottom = header_data(3);
left = header_data(4);
top = header_data(5);
right = header_data(6);

% X,Y data from header
% x = linspace(left,right,xsize);
% y = linspace(bottom,top,ysize);
% [X, Y] = meshgrid(x,y);

%% XY-Position from file
X =reshape(ulam_data(:,4),xsize,ysize);
X = X';
Y =reshape(ulam_data(:,5),xsize,ysize);
Y = Y';

%% U-Velocity
U =reshape(ulam_data(:,1),xsize,ysize);
U = U';
figure;
imagesc(U);
axis equal;
xlim([0,xsize]);
ylim([0,ysize]);
axis off;

%% V-Velocity
V =reshape(ulam_data(:,2),xsize,ysize);
V = V';
figure;
imagesc(V);
axis equal;
xlim([0,xsize]);
ylim([0,ysize]);
axis off;

%% Pressure (needs limiting of range because of divergent terms on the interface (0 < ~1000).) 
lower_limit = 0;
upper_limit = 10000;
P =reshape(ulam_data(:,3),xsize,ysize);
P = P';
figure;
imagesc(P,[lower_limit,upper_limit]);
axis equal;
xlim([0,xsize]);
ylim([0,ysize]);
axis off;

%% Velocity Arrows
figure;
quiver(X,Y,U,V);
axis equal;
xlim([left,right]);
ylim([bottom,top]);

%% Streamlines
figure;
streamslice(X,Y,U,V);
axis equal;
xlim([left,right]);
ylim([bottom,top]);