// ## A user defined scenario
// Please add some description
/*
Ulambator configuration file
Date: 09.12.2014
Version 0.7
*/

// ###File Header
// Together with included classes we add Ulambators `matblc1.h` and `bndblock.h`, which manage the geometry and generate the matrix that solves the posed problem.
#include "../source/matblc1.h"
#include "../source/bndblock.h"
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#ifndef _WIN32
#include <sys/time.h>
#endif
#ifdef _WIN32
#define _USE_MATH_DEFINES // for C++
#include <cmath>
#endif
#include <time.h>
#include <math.h>

// The program begins with `int main` and prints a greeting to the screen.
int main (int argc, char * const argv[]) {
    std::cout <<"Welcome to ULAMBATOR++ v.7\n";
    std::cout <<"Unsteady LAminar Microfluidic Boundary element Algorithm To Obtain Results\n";
	char* savedir;
	
// ###Defining the geometry
// The object `bem` is a boundary block, which works as a container that will manage all boundaries like fixed walls and liquid interfaces. Here we initialize the container to contain only a single boundary.
    int number_of_boundaries = 0;
    BndBlock bem = BndBlock(number_of_boundaries);
    
// ###Creating the matrix
    double LH = 1.0;
    double lambda = 1.0;
    MatBlC1 mat(&bem, LH, lambda, 0.0);


// End of program
    std::cout << "Finished and Exiting\n"; 
    return 0;
}
