(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     10355,        279]
NotebookOptionsPosition[      9877,        257]
NotebookOutlinePosition[     10234,        273]
CellTagsIndexPosition[     10191,        270]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", " ", "=", " ", "\"\<~/directory\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", " ", "=", " ", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"dir", "<>", "\"\</bnd0pos.dat\>\""}], ",", "\"\<Table\>\""}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"s", " ", "=", " ", 
     RowBox[{"IntegerString", "[", 
      RowBox[{"1", "*", "x"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"s2", " ", "=", 
     RowBox[{
     "dir", "<>", "\"\</drop1ts\>\"", "<>", "s", "<>", "\"\<.dat\>\""}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"A", " ", "=", " ", 
     RowBox[{"Import", "[", 
      RowBox[{"s2", ",", "\"\<Table\>\""}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"X1", " ", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"A", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", 
           RowBox[{"-", "1"}]}], ",", 
          RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "~", "Join", "~", 
       RowBox[{"{", " ", 
        RowBox[{"A", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", 
           RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "}"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"s2", " ", "=", 
       RowBox[{
       "dir", "<>", "\"\</drop2ts\>\"", "<>", "s", "<>", "\"\<.dat\>\""}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"A", " ", "=", " ", 
       RowBox[{"Import", "[", 
        RowBox[{"s2", ",", "\"\<Table\>\""}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"X2", " ", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"A", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", 
             RowBox[{"-", "1"}]}], ",", 
            RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "~", "Join", "~", 
         RowBox[{"{", " ", 
          RowBox[{"A", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", 
             RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "}"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"s2", " ", "=", 
       RowBox[{
       "dir", "<>", "\"\</drop3ts\>\"", "<>", "s", "<>", "\"\<.dat\>\""}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"A", " ", "=", " ", 
       RowBox[{"Import", "[", 
        RowBox[{"s2", ",", "\"\<Table\>\""}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"X3", " ", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"A", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", 
             RowBox[{"-", "1"}]}], ",", 
            RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "~", "Join", "~", 
         RowBox[{"{", " ", 
          RowBox[{"A", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", 
             RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "}"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"s2", " ", "=", 
       RowBox[{
       "dir", "<>", "\"\</drop4ts\>\"", "<>", "s", "<>", "\"\<.dat\>\""}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"A", " ", "=", " ", 
       RowBox[{"Import", "[", 
        RowBox[{"s2", ",", "\"\<Table\>\""}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"X4", " ", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"A", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", 
             RowBox[{"-", "1"}]}], ",", 
            RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "~", "Join", "~", 
         RowBox[{"{", " ", 
          RowBox[{"A", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", 
             RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "}"}]}], "}"}]}], 
      ";"}], "*)"}], " ", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"ListLinePlot", "[", 
       RowBox[{"B", ",", 
        RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
        RowBox[{"Axes", "\[Rule]", "False"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1"}], ",", "1.1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1.1"}], ",", "1.1"}], "}"}]}], "}"}]}]}], "]"}], 
      ",", 
      RowBox[{"ListLinePlot", "[", 
       RowBox[{"X1", ",", 
        RowBox[{"Filling", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", "\[Rule]", "1"}], "}"}]}]}], "]"}]}], 
     RowBox[{"(*", 
      RowBox[{",", 
       RowBox[{"ListLinePlot", "[", 
        RowBox[{"X2", ",", 
         RowBox[{"Filling", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1", "\[Rule]", "1"}], "}"}]}]}], "]"}], ",", 
       RowBox[{"ListLinePlot", "[", 
        RowBox[{"X3", ",", 
         RowBox[{"Filling", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1", "\[Rule]", "1"}], "}"}]}]}], "]"}], ",", 
       RowBox[{"ListLinePlot", "[", 
        RowBox[{"X4", ",", 
         RowBox[{"Filling", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1", "\[Rule]", "1"}], "}"}]}]}], "]"}], ","}], "*)"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "100", ",", "1"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.610952609170267*^9, 3.610952639641244*^9}, {
   3.610952698862002*^9, 3.610952703933517*^9}, {3.610952759643774*^9, 
   3.6109527767288237`*^9}, {3.610952839966836*^9, 3.61095285766*^9}, {
   3.610952891457883*^9, 3.610952954541986*^9}, {3.633258981091898*^9, 
   3.633259024606765*^9}, {3.633259061663725*^9, 3.6332591467526484`*^9}, {
   3.633259178559986*^9, 3.633259375676445*^9}, {3.633259406440481*^9, 
   3.6332594445061483`*^9}, {3.633259597522107*^9, 3.633259653677392*^9}, {
   3.633259692005066*^9, 3.633259709269128*^9}, 3.633259860898491*^9, {
   3.633259977449486*^9, 3.633260062468886*^9}, {3.6332601183670263`*^9, 
   3.6332601534772167`*^9}, 3.63326034095541*^9, 3.6332603967832737`*^9, {
   3.6332605331187277`*^9, 3.6332605460935497`*^9}, {3.633677222049171*^9, 
   3.633677255000738*^9}, {3.6336773601869926`*^9, 3.633677479737279*^9}, {
   3.633677510311651*^9, 3.633677560683793*^9}, {3.633677591843409*^9, 
   3.633677631834008*^9}, {3.633681341470687*^9, 3.633681342858725*^9}, {
   3.633801350349883*^9, 3.633801370482736*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`x$$ = 100, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`x$$], 85, 100, 1}}, Typeset`size$$ = {
    360., {178., 182.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`x$32807$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`x$$ = 85}, 
      "ControllerVariables" :> {
        Hold[$CellContext`x$$, $CellContext`x$32807$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, 
      "Body" :> ($CellContext`s = 
        IntegerString[1 $CellContext`x$$]; $CellContext`s2 = 
        StringJoin[$CellContext`dir, "/drop1ts", $CellContext`s, 
          ".dat"]; $CellContext`A = 
        Import[$CellContext`s2, "Table"]; $CellContext`X1 = {
          Join[
           Part[$CellContext`A, 
            Span[2, -1], 
            Span[1, 2]], {
            Part[$CellContext`A, 2, 
             Span[1, 2]]}]}; Show[
         ListLinePlot[$CellContext`B, AspectRatio -> 1, Axes -> False, 
          PlotStyle -> Black, PlotRange -> {{-1.1, 1.1}, {-1.1, 1.1}}], 
         ListLinePlot[$CellContext`X1, Filling -> {1 -> 1}]]), 
      "Specifications" :> {{$CellContext`x$$, 85, 100, 1}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{405., {222., 227.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{
  3.63326015811309*^9, 3.633260227098976*^9, 3.63326026876875*^9, 
   3.633260413101367*^9, {3.633260534827362*^9, 3.6332605472925997`*^9}, {
   3.6336774712460814`*^9, 3.633677480605505*^9}, 3.6336775212800922`*^9, 
   3.633677561826293*^9, {3.633677593353086*^9, 3.633677608621203*^9}, 
   3.633677646427166*^9, 3.633681343989572*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.6332601617762003`*^9, 3.6332601633883038`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<~/Desktop/refl.gif\>\"", ",", "%"}], "]"}]], "Input",
 CellChangeTimes->{{3.633677674111146*^9, 3.633677702914542*^9}}],

Cell[BoxData["\<\"~/Desktop/refl.gif\"\>"], "Output",
 CellChangeTimes->{3.633677727454043*^9}]
}, Open  ]]
},
WindowSize->{740, 822},
WindowMargins->{{103, Automatic}, {Automatic, 0}},
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 20, \
2012)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 6450, 166, 352, "Input"],
Cell[7032, 190, 2422, 50, 466, "Output"]
}, Open  ]],
Cell[9469, 243, 96, 1, 28, "Input"],
Cell[CellGroupData[{
Cell[9590, 248, 173, 3, 28, "Input"],
Cell[9766, 253, 95, 1, 28, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
